/* $Id: language.c,v 1.1 2007/07/15 22:05:23 mgdepalma Exp $
 *
 * Copyright (C) 2007 Softcraft Impresa, LLC <info@softcraft.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; You may only use version 2 of the License,
 * you have no option to use any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "language.h"

/* Deutsch */
static Translation TranslationGerman[] = {
  { LABEL_APPLY,           "Anwenden" },
  { LABEL_CANCEL,          "Abbrechen" },
  { LABEL_CAPTURE,         "Neuer Snapshot" },
  { LABEL_CLOSE,           "Beenden" },
  { LABEL_DECORE,          "Fensterdekorationen mit einbeziehen" },
  { LABEL_DEFAULT,         "Standard" },
  { LABEL_DELAY,           "Snapshot verzoegern" },
  { LABEL_DISMISS,         "Verwerfen" },
  { LABEL_DONE,            "Erledigt" },
  { LABEL_FILE,            "Datei" },
  { LABEL_FILE_EXIST,      "Bereits vorhanden" },
  { LABEL_FILE_TYPE,       "Format" },
  { LABEL_FILE_TYPE_BMP,   "BMP" },
  { LABEL_FILE_TYPE_JPG,   "JPEG" },
  { LABEL_FILE_TYPE_PNG,   "PNG" },
  { LABEL_GRAB,            "Modus" },
  { LABEL_GRAB_REGION,     "Bereich ablichten" },
  { LABEL_GRAB_SCREEN,     "Gesamter Bildschirm" },
  { LABEL_GRAB_WINDOW,     "Fenster unter Cursor" },
  { LABEL_HIDE,            "Fenster verstecken" },
  { LABEL_INFO,		   "Informationen" },
  { LABEL_OK,              "O.K." },
  { LABEL_OPEN,            "Oeffnen" },
  { LABEL_PRINT,           "Druck" },
  { LABEL_PRINT_COMMAND,   "Druck-Befehl" },
  { LABEL_PRINT_INVALID,   "Druck abgebrochen" },
  { LABEL_PRINT_JOB_SENT,  "Druck Job gesendet" },
  { LABEL_PRINT_LANDSCAPE, "Landscape" },
  { LABEL_PRINT_PORTRAIT,  "Portrait" },
  { LABEL_PRINT_TO_FILE,   "Drucken als Datei" },
  { LABEL_PRINTER,         "Drucker" },
  { LABEL_QUIT,            "Schliessen" },
  { LABEL_SAVE,            "Speichern" },
  { LABEL_SAVE_AS,         "Speichern als" },
  { LABEL_SEND_TO,         "Senden zu" },
  { LABEL_SET_BACKGROUND,  "Als Hintergrund" },
  { LABEL_UNIMPLEMENTED,   "Nicht unterstuetzt" },
  { LABEL_VIEW,            "Ansicht" },
  { LABEL_WRITE_OVER,      "Schreiben Sie ueber" },
  { LABEL_X,               "X" }
};

/* Español */
static Translation TranslationSpanish[] = {
  { LABEL_APPLY,           "Apliqese" },
  { LABEL_CANCEL,          "Cancelación" },
  { LABEL_CAPTURE,         "Nueva Foto" },
  { LABEL_CLOSE,           "Cierre" },
  { LABEL_DECORE,          "Incluya las decoraciones" },
  { LABEL_DEFAULT,         "Default" },
  { LABEL_DELAY,           "Foto retrasa" },
  { LABEL_DISMISS,         "Despida" },
  { LABEL_DONE,            "Fait" },
  { LABEL_FILE,            "File" },
  { LABEL_FILE_EXIST,      "Ya exisys" },
  { LABEL_FILE_TYPE,       "Tipo Del Archivo" },
  { LABEL_FILE_TYPE_BMP,   "BMP formato de la imagen" },
  { LABEL_FILE_TYPE_JPG,   "JPEG formato de la imagen" },
  { LABEL_FILE_TYPE_PNG,   "PNG formato de la imagen" },
  { LABEL_GRAB,            "Modo de la captura" },
  { LABEL_GRAB_REGION,     "Región" },
  { LABEL_GRAB_SCREEN,     "Pantalla Entera" },
  { LABEL_GRAB_WINDOW,     "Ventana debajo del cursor" },
  { LABEL_HIDE,            "Uso de la piel" },
  { LABEL_INFO,            "Informaciones" },
  { LABEL_OK,              "OK" },
  { LABEL_OPEN,            "Open" },
  { LABEL_PRINT,           "Impresión" },
  { LABEL_PRINT_COMMAND,   "Impresión" },
  { LABEL_PRINT_INVALID,   "Impresión" },
  { LABEL_PRINT_JOB_SENT,  "Impresión" },
  { LABEL_PRINT_LANDSCAPE, "Landscape" },
  { LABEL_PRINT_PORTRAIT,  "Portrait" },
  { LABEL_PRINT_TO_FILE,   "Impresin a file" },
  { LABEL_PRINTER,         "Impresión" },
  { LABEL_QUIT,            "Salida" },
  { LABEL_SAVE,            "Excepto" },
  { LABEL_SAVE_AS,         "Excepto como" },
  { LABEL_SEND_TO,         "Envíe A" },
  { LABEL_SET_BACKGROUND,  "Fije como fondo" },
  { LABEL_UNIMPLEMENTED,   "Apesadumbrado, no puesto en ejecucio'n" },
  { LABEL_VIEW,            "Visión" },
  { LABEL_WRITE_OVER,      "Escriba Encima" },
  { LABEL_X,               "X" }
};

/* Français */
static Translation TranslationFrench[] = {
  { LABEL_APPLY,           "Appliquez" },
  { LABEL_CANCEL,          "Annulation" },
  { LABEL_CAPTURE,         "Nouvel Instantané" },
  { LABEL_CLOSE,           "Sortie" },
  { LABEL_DECORE,          "Incluez les décorations de fenêtre" },
  { LABEL_DEFAULT,         "Dfaut" },
  { LABEL_DELAY,           "L'instantané retardent" },
  { LABEL_DISMISS,         "Écartez" },
  { LABEL_DONE,            "Fait" },
  { LABEL_FILE,            "File" },
  { LABEL_FILE_EXIST,      "déjà exisys" },
  { LABEL_FILE_TYPE,       "Type de dossier d'image" },
  { LABEL_FILE_TYPE_BMP,   "BMP format d'image" },
  { LABEL_FILE_TYPE_JPG,   "JPEG format d'image" },
  { LABEL_FILE_TYPE_PNG,   "PNG format d'image" },
  { LABEL_GRAB,            "Mode de capture" },
  { LABEL_GRAB_REGION,     "Région" },
  { LABEL_GRAB_SCREEN,     "Écran Entier" },
  { LABEL_GRAB_WINDOW,     "Fenêtre sous le curseur" },
  { LABEL_HIDE,            "Fenêtre d'application de peau" },
  { LABEL_INFO,            "Informations" },
  { LABEL_OK,              "OK" },
  { LABEL_OPEN,            "Ouvert" },
  { LABEL_PRINT,           "Copie" },
  { LABEL_PRINT_COMMAND,   "Commande print" },
  { LABEL_PRINT_INVALID,   "Commande print" },
  { LABEL_PRINT_JOB_SENT,  "Commande print" },
  { LABEL_PRINT_LANDSCAPE, "Landscape" },
  { LABEL_PRINT_PORTRAIT,  "Portrait" },
  { LABEL_PRINT_TO_FILE,   "Copie  file" },
  { LABEL_PRINTER,         "Copie" },
  { LABEL_QUIT,            "Sortie" },
  { LABEL_SAVE,            "Économiser" },
  { LABEL_SAVE_AS,         "Économiser As" },
  { LABEL_SEND_TO,         "Envoyez À" },
  { LABEL_SET_BACKGROUND,  "Placez comme fond" },
  { LABEL_UNIMPLEMENTED,   "Désolé, non mis en application" },
  { LABEL_VIEW,            "Visión" },
  { LABEL_WRITE_OVER,      "Écrivez Plus de" },
  { LABEL_X,               "X" }
};

/* Bahasa Indonesia */
static Translation TranslationIndonesian[] = {
  { LABEL_APPLY,           "Apply" },
  { LABEL_CANCEL,          "tombol tunda" },
  { LABEL_CAPTURE,         "gambar dari layar baru" },
  { LABEL_CLOSE,           "close" },
  { LABEL_DECORE,          "termasuk  dekorasi window" },
  { LABEL_DEFAULT,         "Default" },
  { LABEL_DELAY,           "jangka waktu" },
  { LABEL_DISMISS,         "Dismiss" },
  { LABEL_DONE,            "Done" },
  { LABEL_FILE,            "File" },
  { LABEL_FILE_EXIST,      "already exists" },
  { LABEL_FILE_TYPE,       "File Type" },
  { LABEL_FILE_TYPE_BMP,   "BMP image format" },
  { LABEL_FILE_TYPE_JPG,   "JPEG image format" },
  { LABEL_FILE_TYPE_PNG,   "PNG image format" },
  { LABEL_GRAB,            "pilihan capture" },
  { LABEL_GRAB_REGION,     "hanya sebagian" },
  { LABEL_GRAB_SCREEN,     "layar penuh" },
  { LABEL_GRAB_WINDOW,     "hanya window" },
  { LABEL_HIDE,            "window tidak terlihat" },
  { LABEL_INFO,            "Informations" },
  { LABEL_OK,              "OK" },
  { LABEL_OPEN,            "Open" },
  { LABEL_PRINT,           "Cetak" },
  { LABEL_PRINT_COMMAND,   "Print Command" },
  { LABEL_PRINT_INVALID,   "Invalid Print Command" },
  { LABEL_PRINT_JOB_SENT,  "Job sent to printer" },
  { LABEL_PRINT_LANDSCAPE, "Landscape" },
  { LABEL_PRINT_PORTRAIT,  "Portrait" },
  { LABEL_PRINT_TO_FILE,   "Cetak file" },
  { LABEL_PRINTER,         "Cetak" },
  { LABEL_QUIT,            "Keluar" },
  { LABEL_SAVE,            "Simpan" },
  { LABEL_SAVE_AS,         "Disimpan didalam file" },
  { LABEL_SEND_TO,         "Send To" },
  { LABEL_SET_BACKGROUND,  "Set as background" },
  { LABEL_UNIMPLEMENTED,   "Sorry, not implemented" },
  { LABEL_VIEW,            "View" },
  { LABEL_WRITE_OVER,      "Write Over" },
  { LABEL_X,               "X" }
};

/* Italiano */
static Translation TranslationItalian[] = {
  { LABEL_APPLY,           "Applica" },
  { LABEL_CANCEL,          "Annulla" },
  { LABEL_CAPTURE,         "Nuova Fotografia" },
  { LABEL_CLOSE,           "Chiudi" },
  { LABEL_DECORE,          "Includa le decorazioni della finestra" },
  { LABEL_DEFAULT,         "Sistema" },
  { LABEL_DELAY,           "Fotografia far ritardare" },
  { LABEL_DISMISS,         "Riconosco" },
  { LABEL_DONE,            "Fatto" },
  { LABEL_FILE,            "File" },
  { LABEL_FILE_EXIST,      "già esiste" },
  { LABEL_FILE_TYPE,       "Typo di file" },
  { LABEL_FILE_TYPE_BMP,   "BMP disposizione di immagine" },
  { LABEL_FILE_TYPE_JPG,   "JPEG disposizione di immagine" },
  { LABEL_FILE_TYPE_PNG,   "PNG disposizione di immagine" },
  { LABEL_GRAB,            "Modo di cattura" },
  { LABEL_GRAB_REGION,     "Regione" },
  { LABEL_GRAB_SCREEN,     "Intero Schermo" },
  { LABEL_GRAB_WINDOW,     "Finestra sotto il cursor" },
  { LABEL_HIDE,            "Nacondi la finestra della applicazione" },
  { LABEL_INFO,            "Informazioni" },
  { LABEL_OK,              "OK" },
  { LABEL_OPEN,            "Apri" },
  { LABEL_PRINT,           "Stampa" },
  { LABEL_PRINT_COMMAND,   "Ordine Di Stampa" },
  { LABEL_PRINT_INVALID,   "Ordine Di Stampa Non valido" },
  { LABEL_PRINT_JOB_SENT,  "Lavoro trasmesso allo stampatore" },
  { LABEL_PRINT_LANDSCAPE, "Landscape" },
  { LABEL_PRINT_PORTRAIT,  "Portrait" },
  { LABEL_PRINT_TO_FILE,   "Stampa a file" },
  { LABEL_PRINTER,         "Stampatrice" },
  { LABEL_QUIT,            "Esci" },
  { LABEL_SAVE,            "Salva" },
  { LABEL_SAVE_AS,         "Salva Come" },
  { LABEL_SEND_TO,         "Spedisci a" },
  { LABEL_SET_BACKGROUND,  "Usi come sfondo" },
  { LABEL_UNIMPLEMENTED,   "Spiacente, non effettuato" },
  { LABEL_VIEW,            "Vista" },
  { LABEL_WRITE_OVER,      "Scriva Sopra" },
  { LABEL_X,               "X" }
};

/* 日本語 (Nihongo) */
static Translation TranslationJapanese[] = {
  { LABEL_APPLY,           "Apply" },
  { LABEL_CANCEL,          "取り消し" },
  { LABEL_CAPTURE,         "新しいスナップショット" },
  { LABEL_DECORE,          "窓の装飾を含みなさい" },
  { LABEL_DEFAULT,         "Default" },
  { LABEL_DELAY,           "捕獲の遅れ" },
  { LABEL_DISMISS,         "退去させなさい" },
  { LABEL_DONE,            "される" },
  { LABEL_FILE,            "File" },
  { LABEL_FILE_EXIST,      "already exists" },
  { LABEL_FILE_TYPE,       "イメージファイルのタイプ" },
  { LABEL_FILE_TYPE_BMP,   "BMP のイメージのフォーマット" },
  { LABEL_FILE_TYPE_JPG,   "JPEG のイメージのフォーマット" },
  { LABEL_FILE_TYPE_PNG,   "PNG のイメージのフォーマット" },
  { LABEL_GRAB,            "捕獲モード" },
  { LABEL_GRAB_REGION,     "長方形の地域" },
  { LABEL_GRAB_SCREEN,     "全体のスクリーン" },
  { LABEL_GRAB_WINDOW,     "カーソルの下の窓" },
  { LABEL_HIDE,            "の塗布の窓 隠れること" },
  { LABEL_INFO,            "Informations" },
  { LABEL_OK,              "わかりました" },
  { LABEL_OPEN,            "Open" },
  { LABEL_PRINT,           "印刷物スタンプ" },
  { LABEL_PRINT_COMMAND,   "Print Command" },
  { LABEL_PRINT_INVALID,   "Print Command Invalid" },
  { LABEL_PRINT_JOB_SENT,  "Job sent to printer" },
  { LABEL_PRINT_LANDSCAPE, "Landscape" },
  { LABEL_PRINT_PORTRAIT,  "Portrait" },
  { LABEL_PRINT_TO_FILE,   "Print to file" },
  { LABEL_PRINTER,         "印刷物スタンプ" },
  { LABEL_QUIT,            "やめられる" },
  { LABEL_SAVE,            "を除けば" },
  { LABEL_SAVE_AS,         "を除けばようにk" },
  { LABEL_SEND_TO,         "Send To" },
  { LABEL_SET_BACKGROUND,  "Set as background" },
  { LABEL_UNIMPLEMENTED,   "残念、実行されない。" },
  { LABEL_VIEW,            "なさい" },
  { LABEL_WRITE_OVER,      "Write Over" },
  { LABEL_X,               "X" }
};

/* 繁體中文 */
static Translation TranslationTChinese[] = {
  { LABEL_APPLY,           "套用" },
  { LABEL_CANCEL,          "取消" },
  { LABEL_CAPTURE,         "新的快照" },
  { LABEL_CLOSE,           "關閉" },
  { LABEL_DECORE,          "包含視窗外框" },
  { LABEL_DEFAULT,         "預設" },
  { LABEL_DELAY,           "快照延遲" },
  { LABEL_DISMISS,         "去除" },
  { LABEL_DONE,            "完成" },
  { LABEL_FILE,            "檔案" },
  { LABEL_FILE_EXIST,      "已經存在" },
  { LABEL_FILE_TYPE,       "檔案類型" },
  { LABEL_FILE_TYPE_BMP,   "BMP 圖像格式" },
  { LABEL_FILE_TYPE_JPG,   "JPEG 圖像格式" },
  { LABEL_FILE_TYPE_PNG,   "PNG 圖像格式" },
  { LABEL_GRAB,            "抓取模式" },
  { LABEL_GRAB_REGION,     "螢幕區域" },
  { LABEL_GRAB_SCREEN,     "整個螢幕" },
  { LABEL_GRAB_WINDOW,     "滑鼠所指視窗" },
  { LABEL_HIDE,            "隱藏本軟體視窗" },
  { LABEL_INFO,            "資訊" },
  { LABEL_OK,              "確定" },
  { LABEL_OPEN,            "開啟" },
  { LABEL_PRINT,           "列印" },
  { LABEL_PRINT_COMMAND,   "列印指令" },
  { LABEL_PRINT_INVALID,   "列印指令無效" },
  { LABEL_PRINT_JOB_SENT,  "工作傳送到印表機" },
  { LABEL_PRINT_LANDSCAPE, "橫印" },
  { LABEL_PRINT_PORTRAIT,  "直印" },
  { LABEL_PRINT_TO_FILE,   "列印到檔案" },
  { LABEL_PRINTER,         "印表機" },
  { LABEL_QUIT,            "離開" },
  { LABEL_SAVE,            "儲存" },
  { LABEL_SAVE_AS,         "另存新檔" },
  { LABEL_SEND_TO,         "傳送到" },
  { LABEL_SET_BACKGROUND,  "設為螢幕背景" },
  { LABEL_UNIMPLEMENTED,   "抱歉，尚未實做" },
  { LABEL_VIEW,            "檢視" },
  { LABEL_WRITE_OVER,      "覆寫" },
  { LABEL_X,               "X" }
};

/* (Default) English */
static Translation TranslationEnglish[] = {
  { LABEL_APPLY,           "Apply" },
  { LABEL_CANCEL,          "Cancel" },
  { LABEL_CAPTURE,         "New Snapshot" },
  { LABEL_CLOSE,           "Close" },
  { LABEL_DECORE,          "Include window decorations" },
  { LABEL_DEFAULT,         "Default" },
  { LABEL_DELAY,           "Snapshot delay" },
  { LABEL_DISMISS,         "Dismiss" },
  { LABEL_DONE,            "Done" },
  { LABEL_FILE,            "File" },
  { LABEL_FILE_EXIST,      "already exists" },
  { LABEL_FILE_TYPE,       "File Type" },
  { LABEL_FILE_TYPE_BMP,   "BMP image format" },
  { LABEL_FILE_TYPE_JPG,   "JPEG image format" },
  { LABEL_FILE_TYPE_PNG,   "PNG image format" },
  { LABEL_GRAB,            "Capture mode" },
  { LABEL_GRAB_REGION,     "Region" },
  { LABEL_GRAB_SCREEN,     "Entire Screen" },
  { LABEL_GRAB_WINDOW,     "Window under cursor" },
  { LABEL_HIDE,            "Hide application window" },
  { LABEL_INFO,            "Informations" },
  { LABEL_OK,              "OK" },
  { LABEL_OPEN,            "Open" },
  { LABEL_PRINT,           "Print" },
  { LABEL_PRINT_COMMAND,   "Print Command" },
  { LABEL_PRINT_INVALID,   "Print Command Invalid" },
  { LABEL_PRINT_JOB_SENT,  "Job sent to printer" },
  { LABEL_PRINT_LANDSCAPE, "Landscape" },
  { LABEL_PRINT_PORTRAIT,  "Portrait" },
  { LABEL_PRINT_TO_FILE,   "Print to file" },
  { LABEL_PRINTER,         "Printer" },
  { LABEL_QUIT,            "Quit" },
  { LABEL_SAVE,            "Save" },
  { LABEL_SAVE_AS,         "Save As" },
  { LABEL_SEND_TO,         "Send To" },
  { LABEL_SET_BACKGROUND,  "Set as background" },
  { LABEL_UNIMPLEMENTED,   "Sorry, not implemented" },
  { LABEL_VIEW,            "View" },
  { LABEL_WRITE_OVER,      "Write Over" },
  { LABEL_X,               "X" }
};
static Translation *spoken = NULL;

/*
 * Given a constant text string provide the localized string.
 */
gchar *
_L(Label label)
{
  if (spoken == NULL) {
    char *lang = getenv("LANG");
    if (strncmp(lang, "de", 2) == 0)
      spoken = TranslationGerman;
    else if (strncmp(lang, "es", 2) == 0)
      spoken = TranslationSpanish;
    else if (strncmp(lang, "fr", 2) == 0)
      spoken = TranslationFrench;
    else if (strncmp(lang, "id", 2) == 0)
      spoken = TranslationIndonesian;
    else if (strncmp(lang, "it", 2) == 0)
      spoken = TranslationItalian;
    else if (strncmp(lang, "ja", 2) == 0)
      spoken = TranslationJapanese;
    else if (strncmp(lang, "zh_TW", 5) == 0)
      spoken = TranslationTChinese;
    else
      spoken = TranslationEnglish;
  }
  return spoken[label].locale;
} /* </_L> */

/*
 * return name with any leading directory components removed
 */
gchar *
basename(const gchar *path)
{
  static gchar name[MAX_PATH_LENGTH];
  gchar *scan;

  g_stpcpy(name, path);
  scan = g_strrstr(name, "/");

  return (scan != NULL) ? ++scan : name;
} /* </basename> */

/*
 * strargs returns a string with the format and string given
 */
gchar *
strargs(const gchar *format, ...)
{
  static gchar message[1024];

  va_list ap;
  va_start(ap, format);
  g_vsprintf(message, format, ap);
  va_end(ap);

  return message;
} /* </strargs> */

