Name:           gsnapshot
Version:        1.0
Release:        %mkrel 2
License:        GPL
Source0:        %{name}-%{version}.tar.xz
Source1:	%{name}-language.c
URL:            http://www.softcraft.org/gsnapshot/
Group:          Graphics
Packager:       OSS Integral Institute, Co. Ltd.
Summary:        A GTK2 application for capturing a screen snapshot
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  gtk2-devel
Requires:	gtk2

%description
A GTK2 application for capturing a screen snapshot of the entire screen,
a window or a region, with a simple user interface.

%prep

%setup -q -n %{name}
#1.1 %setup -q
%__cp -f %{SOURCE1} src/language.c

%build
./autogen.sh
./configure --prefix=/usr
%{__make}

%install
%{__make} DESTDIR=%{buildroot} install
%{__install} -D -m 644 src/icons/%{name}.png %{buildroot}%{_datadir}/pixmaps/%{name}.png

mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Encoding=UTF-8
Name=GSnapshot
Name[zh_TW]=GTK 畫面快照
Comment=for capturing a screen snapshot
Comment[zh_TW]=GSnapshot 是適用於 GTK 的畫面快照
Comment[de]=Bildschirmfotos erstellen
Exec=gsnapshot
Icon=gsnapshot
Terminal=false
Type=Application
Categories=GTK;Graphics;X-MandrivaLinux-Multimedia-Graphics;
EOF

%clean
rm -rf %{buildroot}
rm -rf $RPM_BUILD_DIR/%{name}

%files
%defattr(-,root,root)
%{_bindir}/*
%{_datadir}/applications/%{name}.desktop
%{_datadir}/pixmaps/%{name}.png
%exclude /usr/lib/*
%exclude %{_includedir}/*

%changelog
* Mon Jul 15 2013 Texstar <texstar at gmail.com> 1.0-2pclos2013
- fix rpm group Graphics

* Fri Apr 13 2012 leiche <meisssw01 at gmail.com> 1.0-1leiche2012
- initial package
